//////////////////////////////////////////////////////////////////////////////
//
// Implementation of the min CUT algorithm
// It is not examined for sufficient memory!
// 
// to compiling under linux: gcc mincut.c -Wall -O2 -o mincut
//
//////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include<math.h>

//////////////////////////////////////////////////////////////////////////////
//
// Type declarations
//
//////////////////////////////////////////////////////////////////////////////

// List for storing the quantities of the knots of the original graph, which is summarized in new knot. 
// Realization as simple concatenates list with pointer on first and last element. 
// The pointer of NEXT of the last element always points to NULL.

float *ai,*Ai,*ri,*Ri,*delta;
float *visited,*shortest_path,*visited2,*longest_path,*visited3;
int END  = 14;
float MIN=1000,MAX=0,THRESHOLD=500;
float **MIN_MATRIX,**MAX_MATRIX;

FILE *f = fopen("old graph info.txt","w");


typedef struct node{
  int data;
  float weight;
  float min;
  float max;
  struct node *next;
  //struct node *parent;
} edge;


struct t_node {
  int vertex;
  struct t_node* next;
};

struct t_vertex_list { 
  struct t_node* first;
  struct t_node* last;
};

// Die Problemdaten als Struktur:
struct t_problem {
  int n;                         // Number of knots in the original graph
  int curr_n;                    // Number of knots in the current graph
  double** edgeweight;           // Edge weights as two-dimensional, symmetrical field.

  struct t_vertex_list* v_lists; // List of the knots of the original graph, which is summarized in the ith knot.

  int* next_vertex;              
  int* prev_vertex;              // the quantity of the used indices as doubly concatenated list (realizes with 2 fields). 
								 // next_vertex[i ] the next higher used index is accordingly after i, prev_vertex. 
								 // The range of the arrays goes simplifying index from the list from -1 to n around removing.
};

// Structure for the return value of the sequence search function:
struct t_sequence_end {
  int last,second_last;          // The two last knots of the sequence
  double weightsum;              // Sum of the weights with read inzidenten edges
};
// Structure for the return value of the algorithm
struct  t_solution {
  struct t_vertex_list cutset;   // cut-defining knot quantity
  double cut_value;              // Weight of the cut
};


//////////////////////////////////////////////////////////////////////////////
//
// Functions for manipulating (et cetera) the knot lists
//
//////////////////////////////////////////////////////////////////////////////

struct t_vertex_list new_vertex_list(int vertex)
// produces a 1-elementige list with the knot vertex.
{
  struct t_vertex_list result;
  struct t_node* node = (struct t_node*)malloc(sizeof(struct t_node));
  node->vertex = vertex;
  node->next = NULL;
  result.first = result.last = node;
  return result;
}

struct t_vertex_list concat_vertex_list(struct t_vertex_list l1, struct t_vertex_list l2)
// hangs the lists l1 and l2 one behind the other. The elements are not copied thereby _ _, 
// thus no later accesses to l1 and l2 possible.
{
  struct t_vertex_list result;
  result.first = l1.first;
  result.last = l2.last;
  l1.last->next = l2.first;
  return result;
} 

struct t_vertex_list copy_vertex_list(struct t_vertex_list l)
// produces a copy of a knot list. l may not be empty!
{
  struct t_vertex_list result;
  struct t_node* k;  // "Zhl"variable
  struct t_node* h;  // Hilfsvariable;

  // produce dummy element (at the end again one removes):
  result.first = result.last = (struct t_node*)malloc(sizeof(struct t_node)); 

  for (k = l.first; k!=NULL; k = k->next) {
    h = (struct t_node*)malloc(sizeof(struct t_node)); 
    h->vertex = k->vertex;
    result.last->next = h;
    result.last = h;
  }
  result.last->next = NULL;

  // Dummy element remove:
  h = result.first;
  result.first = h->next;
  free(h);

  return result;
}

void print_vertex_list(struct t_vertex_list l)
// the list l writes on stdout
{
  while (l.first!=l.last) {
    printf("%i,",l.first->vertex);
    l.first=l.first->next;
  }
  printf("%i",l.first->vertex);
}

void free_vertex_list(struct t_vertex_list l)
// releases the dynamic memory of a list again.
{
  while (l.first!=NULL) {
    struct t_node* h = l.first;
    l.first = l.first->next;
    free(h);
  }
}

//////////////////////////////////////////////////////////////////////////////
//
// Read in the problem
//
//////////////////////////////////////////////////////////////////////////////

struct t_problem read_problem(FILE* f)
{
  struct t_problem prob;
  int n,m;   // Number of knot/edges
  int k,l;   // Counting and artificial variables
  double c;  // Artificial variable

  // 1.) Number of knots and edges read in:
  // ==========
  if (2!=fscanf(f," %i %i",&n,&m)) {
    fprintf(stderr,"error reading data\n");
    exit(0);
  }
  prob.n = prob.curr_n = n;

  // 2.) Memory for edgeweight request and knot lists provide:
  // ==========
  prob.edgeweight = (double**)malloc(sizeof(double*)*n);
  for (k = 0; k < n; k++) {
    prob.edgeweight[k] = (double*)malloc(sizeof(double)*n);
  }
  for (k = 0; k < n; k++) {
    for (l = 0; l < n; l++) {
      prob.edgeweight[k][l] = 0.0;
    }
  } 
  prob.v_lists = (struct t_vertex_list*)malloc(sizeof(struct t_vertex_list)*n);
  for (k = 0; k < n; k++) {
    prob.v_lists[k] = new_vertex_list(k);
  }

  // 3.) List of the used indices provide, initial value: 0..n-1
  // ==========
  // shift of the range to -1..n causes the "1+":
  prob.next_vertex = 1+(int*)malloc(sizeof(int)*(n+2));  
  prob.prev_vertex = 1+(int*)malloc(sizeof(int)*(n+2));
  for (k = -1; k <= n; k++) {
    prob.next_vertex[k] = k+1;
    prob.prev_vertex[k] = k-1;
  }

  // 4.) Edges read in:
  // ==========
  while (m>0) {
    if (3!=fscanf(f," %i %i %lf",&k,&l,&c)||
        ((unsigned)k >= n)||((unsigned)l >= n)||(c < 0.0)) {
      fprintf(stderr,"error reading data\n");
      exit(0);
    }
    prob.edgeweight[k][l] = prob.edgeweight[l][k] = c;
    //prob.edgeweight[k][l] =  c;
    m--;
  }

  return prob;
}
float function(float min,float max){
	//if(min>=.75*MAX)
	//	return 9999;
	//else if(max<=THRESHOLD)
	//	return 0;
	//else if(min<THRESHOLD)
	if(max<=THRESHOLD)
		return min+max;
	else if((THRESHOLD-min)<(MAX-max))
		return max+min;
	else if(max>.9*MAX)
		return 99999;
	else
		return 9999*sqrt((max-THRESHOLD)/(MAX-THRESHOLD))*sqrt((min-MIN)/(THRESHOLD-MIN));
	//else
	//	return max+min;
}
struct t_problem read_problem2(edge **adjacency,int end)
{
  struct t_problem prob;  // Number of knot/edges
  int k,l;   // Counting and artificial variables
  //double c;  // Artificial variable
  int i;
  edge *p;

  // 1.) Number of knots and edges read in:
  // ==========
  prob.n = prob.curr_n = end;
  END = 1;//checkkk

  // 2.) Memory for edgeweight request and knot lists provide:
  // ==========
  prob.edgeweight = (double**)malloc(sizeof(double*)*end);
  for (k = 0; k < end; k++) {
    prob.edgeweight[k] = (double*)malloc(sizeof(double)*end);
  }
  for (k = 0; k < end; k++) {
    for (l = 0; l < end; l++) {
      prob.edgeweight[k][l] = 0.0;
    }
  } 
  prob.v_lists = (struct t_vertex_list*)malloc(sizeof(struct t_vertex_list)*end);
  for (k = 0; k < end; k++) {
    prob.v_lists[k] = new_vertex_list(k);
  }

  // 3.) List of the used indices provide, initial value: 0..n-1
  // ==========
  // shift of the range to -1..n causes the "1+":
  prob.next_vertex = 1+(int*)malloc(sizeof(int)*(end+2));  
  prob.prev_vertex = 1+(int*)malloc(sizeof(int)*(end+2));
  for (k = -1; k <= end; k++) {
    prob.next_vertex[k] = k+1;
    prob.prev_vertex[k] = k-1;
  }

  // 4.) Edges read in:
  // ==========
  for(i=0;i<end;i++){
	  p=adjacency[i];
	  //if(delta[i]>0)//check point
	  while(p){
		k=i;
		l = p->data;
	  //if(delta[l]>0)//check point
		//if(p->min<THRESHOLD)//check point
			//if((THRESHOLD-p->min)<(MAX-p->max))
			//if((THRESHOLD+MAX)/2>(p->weight+Ai[i]+longest_path[l]))
		//	if((THRESHOLD+MAX)/2>(p->max))
				//prob.edgeweight[k][l] = prob.edgeweight[l][k] = p->min+p->max;// make it p->min+p->max
		prob.edgeweight[k][l] = prob.edgeweight[l][k] = function(p->min,p->max);// make it p->min+p->max
		//		prob.edgeweight[k][l] = prob.edgeweight[l][k] = 2*p->weight+ai[i]+Ai[i]+shortest_path[l]+longest_path[l];// make it p->min+p->max
		//	else
		//		prob.edgeweight[k][l] = prob.edgeweight[l][k] = 100*(2*p->weight+ai[i]+Ai[i]+shortest_path[l]+longest_path[l]);//check point
				//prob.edgeweight[k][l] = prob.edgeweight[l][k] = 100*(p->max+p->min);//check point
				
		//else
		//	prob.edgeweight[k][l] = prob.edgeweight[l][k] = 0;
		p=p->next;
	  }
    //prob.edgeweight[k][l] =  c;
  }

  return prob;
}

void printTheProblem(struct t_problem prob){
	FILE *f;
	f = fopen("check.txt","w");
	fprintf(f,"\ncurr_n is %d",prob.curr_n);
	for(int i=0;i<prob.curr_n;i++){
		fprintf(f,"\n");
		for(int j=0;j<prob.curr_n;j++)
			fprintf(f,"%.2f  ",prob.edgeweight[i][j]);
	}
}

//////////////////////////////////////////////////////////////////////////////
//
// Knot contraction
//
//////////////////////////////////////////////////////////////////////////////

struct t_problem contract_vertices(struct t_problem prob,int i,int j)
// contract the knots i and j of the problem rehearse. The data copied thereby _ not _, 
// thus no later accesses to original rehearse possible.
{
  int k; // Counting and artificial variable

  // 1.) Weights from j to those of i add, i.e. column/lines add:
  // ==========
  for (k = prob.next_vertex[-1]; k < prob.n; k = prob.next_vertex[k]) {
    prob.edgeweight[i][k] += prob.edgeweight[j][k];
    prob.edgeweight[k][i] += prob.edgeweight[k][j];
  }
  // Diagonal element correct (is not used actually redundantly, there):
  prob.edgeweight[i][i] = 0.0;

  // 2.) Knot lists concatenate, prob.v_list[j ] are not valid thereafter any longer!
  // ==========
  prob.v_lists[i] = concat_vertex_list(prob.v_lists[i],prob.v_lists[j]);

  // 3.) Knoten j aus der Liste der benutzten Indizes entfernen:
  // ==========
  int pred = prob.prev_vertex[j]; // Vorgnger von j in der Liste
  int succ = prob.next_vertex[j]; // Nachfolger von j in der Liste
  prob.next_vertex[pred] =  succ;
  prob.prev_vertex[succ] =  pred;
  // Hinweis: hier zahlen sich die vier zustzlichen Eintrge 
  // (jeweils ...[-1] und ...[n]) aus, da keine Sonderflle auftreten.

  prob.curr_n--;
  return prob;
}

  
//////////////////////////////////////////////////////////////////////////////
//
// Determine the knot sequence
//
//////////////////////////////////////////////////////////////////////////////


struct t_sequence_end find_sequence(const struct t_problem prob)
// Determines the looked for knot sequence and returns two the latter
// knots as well as the edge weight sum.
{

  struct t_sequence_end result;
  result.last=0;
  // The sequence does not have to be stored explicitly, it hands the last two knots. 
  // Those are result.last in and stored result.second_last.

  int k,l; // Zhlvariablen;

  // , NEXT realizes the knots as doubly concatenated list, not selected yet, and prev with fields. 
  // As initial values a copy of the list of the used indices out rehearse:
  int* next = 1+(int*)malloc(sizeof(int)*(prob.n+2));  
  int* prev = 1+(int*)malloc(sizeof(int)*(prob.n+2));  
  for (k = -1; k <= prob.n; k++) {
    next[k] = prob.next_vertex[k];
    prev[k] = prob.prev_vertex[k];
	//fprintf(f,"for k = %d next[k]%d prev[k]%d\n",k,next[k],prev[k]);
  }

  // Summe der Gewichte der Kanten zu bereits ausgewhlten Knoten,
  // Speicher allokieren und  initialisieren:
  double* sum = (double*)malloc(sizeof(double)*prob.n);  
  for (k = next[-1]; k < prob.n; k = next[k]) { sum[k] = 0.0; }      

  // Bestimmen der Reihenfolge:
  for (k = 0; k < prob.curr_n; k++) {  
    //bestimme k-tes Element:
    double max_sum = -1.0;    // grter sum-Wert
    int max_idx = -1;         // zugehriger Index
    for (l = next[-1]; l < prob.n; l = next[l]) {
      if (sum[l] > max_sum) {
        max_sum = sum[l];
        max_idx = l;
      }
    }

    // max_idx als akutelles Reihenfolgeende eintragen:
    result.second_last = result.last;
    result.last = max_idx;
    result.weightsum = max_sum;

    // max_idx aus Liste entfernen:
    int pred = prev[max_idx]; // Vorgnger von max_idx in der Liste
    int succ = next[max_idx]; // Nachfolger von max_idx in der Liste
    next[pred] =  succ;
    prev[succ] =  pred;

    // sum aktualisieren:
    for (l = next[0]; l < prob.n; l = next[l]) {
      sum[l] += prob.edgeweight[max_idx][l];
    }
  }

  // Speicher freigeben:
  free(sum);
  free(next-1);         // aufpassen, den richtigen Bereich freizugeben!
  free(prev-1);

  return result;
}

//////////////////////////////////////////////////////////////////////////////
//
// The algorithm
//
//////////////////////////////////////////////////////////////////////////////
int listContainsEnd(struct t_vertex_list v_lists){
	t_node *first;
	first = v_lists.first;
	int succ = 0;
	while(first){
		if (first->vertex == 0)
			return 0;
		else if(first->vertex == END)
			succ = 1;
		first=first->next;
	}
	return succ;
}


struct t_solution solve_problem(struct t_problem prob)
// The cut problem loosens edgweights, the index lists and all knot lists in rehearses is released.
{
  struct t_solution solution;
  int first_cycle = 1; // erster Schleifendurchlauf? 
  int k;               // Zhlvariable
  int count = 0;
  int final_count = 0;
  while (prob.curr_n > 1) {
    // determine end of the sequence:
    struct t_sequence_end seq = find_sequence(prob);
    // if necessary store cut:
    if (first_cycle==1 && listContainsEnd(prob.v_lists[seq.last])) {
		//fprintf(f,"first cycle chosen cut value is %f, count %d\n",seq.weightsum, count);
      solution.cutset    = copy_vertex_list(prob.v_lists[seq.last]);
      solution.cut_value = seq.weightsum;
      first_cycle = 0;
	  final_count = count;
    }
    else {
		//fprintf(f,"\n");
      if (seq.weightsum < solution.cut_value && listContainsEnd(prob.v_lists[seq.last])) {
		//fprintf(f,"chosen; are we here at all!");
		//fprintf(f," here at all! cut value is %f count %d\n",seq.weightsum, count);
        free_vertex_list(solution.cutset);
        solution.cutset    = copy_vertex_list(prob.v_lists[seq.last]);
        solution.cut_value = seq.weightsum;
		final_count = count;
      }
	  //else
		//fprintf(f,"discarded cut value is %f count %d\n",seq.weightsum, count);
		  

    }
    count++;    
    // contract knots:
    prob = contract_vertices(prob,seq.second_last,seq.last);
  }

  if (first_cycle == 1) {
	  printf("MIN CUT NEVER FOUND, ALGM FAILED\n");
  }
  else
	  printf("MIN CUT SEQUENCE RAN %d TIMES, USEFUL RESULT IN %d TIMES\n",count, final_count);
  // Memory release:
  for (k = 0; k < prob.n; k++) {
    free(prob.edgeweight[k]);
  }
  free(prob.edgeweight);
  free_vertex_list(prob.v_lists[0]);
  free(prob.v_lists);
  free(prob.next_vertex-1); // watch out to release the correct range!
  free(prob.prev_vertex-1);
  return solution;
}
